= nng_http_res_set_reason(3http)
//
// Copyright 2018 Staysail Systems, Inc. <info@staysail.tech>
// Copyright 2018 Capitar IT Group BV <info@capitar.com>
//
// This document is supplied under the terms of the MIT License, a
// copy of which should be located in the distribution where this
// file was obtained (LICENSE.txt).  A copy of the license may also be
// found online at https://opensource.org/licenses/MIT.
//

== NAME

nng_http_res_set_reason - set HTTP response reason

== SYNOPSIS

[source, c]
----
#include <nng/nng.h>
#include <nng/supplemental/http/http.h>

int nng_http_res_set_reason(nng_http_res *res, const char *reason);
----

== DESCRIPTION

The `nng_http_res_set_reason()` sets the human readable reason
associated with the response _res_ to _reason_.

If the value of _reason_ is `NULL` (the default), then a default reason
phrase is supplied based upon the value of the status code (see
xref:nng_http_res_set_status.3http.adoc[`nng_http_res_set_status()`]).

TIP: The _reason_ is never parsed automatically, but it can be a hint for humans
     to help them understand the nature of any erroneous result.

A local copy of the _reason_ is made in the response _res_.

== RETURN VALUES

This function returns 0 on success, and non-zero otherwise.

== ERRORS

[horizontal]
`NNG_ENOMEM`:: Insufficient memory to perform the operation.
`NNG_ENOTSUP`:: No support for HTTP in the library.

== SEE ALSO

[.text-left]
xref:nng_http_res_alloc.3http.adoc[nng_http_res_alloc(3http)],
xref:nng_http_res_get_reason.3http.adoc[nng_http_req_get_reason(3http)],
xref:nng_http_res_set_status.3http.adoc[nng_http_req_set_status(3http)],
xref:nng.7.adoc[nng(7)]
